import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.Iterator; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class TwoHoursForTwoHours extends PApplet {



final int FRAME_WIDTH = 640;
final int FRAME_HEIGHT = 640;

final float RESTART_TIME = 1.0f;
final float RESTART_TIME_TWO = 3.0f;

int lastMillis, typedCharacters, score, mode;

int seconds = 60 * 60 * 2;

float delta, currentAngle, restartTimer, restartTimerTwo, timer;

boolean ready;

String[] fontList;

char[] twoHoursCharArray = {'t', 'w', 'o', ' ', 'h', 'o', 'u', 'r', 's'};
char[] filler = {'!', '@', '#', '$', '%', '^', '&', '*', '(', ')', '-', '+'};

ArrayList<TwoHourString> strings;

PFont officialFont;

public void setup() {
  frameRate(60.0f);
  size(FRAME_WIDTH, FRAME_HEIGHT);
  fontList = PFont.list();
  strings = new ArrayList<TwoHourString>();
  officialFont = loadFont("Courier-24.vlw");
}

public void draw() {
  delta = (millis() - lastMillis) / 1000.0f;
  lastMillis = millis();
  background(0);
  if(mode == 1) {
    Iterator iterator = strings.iterator();
    while(iterator.hasNext()) {
      TwoHourString s = (TwoHourString) iterator.next();
      s.display();
    }
    timer += delta;
    if(timer > 1.0f) {
      seconds--;
      timer -= 1.0f;
      if(seconds == 0) {
        mode = 2;
        strings = new ArrayList<TwoHourString>();
      }
    }
    fill(255);
    textFont(officialFont);
    text("Score: " + str(score), 12, 24);
    textAlign(CENTER, RIGHT);
    text("Timer: " + str(seconds), 540, 24);
    textAlign(LEFT, CENTER);
  } else if(mode == 0) {
    textFont(officialFont);
    textAlign(CENTER, CENTER);
    text("TWO HOURS IN TWO HOURS\n\nby Total Bummer!\n\ntype 'Two Hours' as many times as possible\nin two hours\n\npress any key to begin", 320, 320);
  } else if(mode == 2 || mode == 3) {
    if(mode == 2) {
      restartTimerTwo += delta;
      if(restartTimerTwo >= RESTART_TIME_TWO) {
        println("Ready");
        ready = true;
        restartTimerTwo = 0.0f;
      }
    }
    textFont(officialFont);
    textAlign(CENTER, CENTER);
    text("FINAL SCORE: " + str(score) + "\n\npress any key to try again", 320, 320);
    if(mode == 3) {
      restartTimer += delta;
      if(restartTimer >= RESTART_TIME) {
        mode = 1;
        restartTimer = 0.0f;
        score = 0;
        seconds = 60 * 60 * 2;
        typedCharacters = 0;
      }
    }
  }
}

public void keyPressed() {
  if(mode == 1) {
    if(typedCharacters == 0) {
      strings.add(new TwoHourString(fontList));
    }
    
    char currentChar;
    if(Character.toLowerCase(key) == twoHoursCharArray[typedCharacters]) {
      currentChar = key;
      strings.get(strings.size() - 1).addCharacter(currentChar, typedCharacters);
      typedCharacters++;
      if(typedCharacters == 9) {
        score++;
        typedCharacters = 0;
      }
    } else {
      currentChar = filler[floor(random(filler.length))];
      strings.get(strings.size() - 1).addCharacter(currentChar, typedCharacters);
      typedCharacters = 0;
    }
  } else if(mode == 0) {
    mode = 1;
  } else if(mode == 2 && ready) {
    mode = 3;
    ready = false;
  }
}
class TwoHourString {
  float angle;
  
  char[] typedLetters = {' ', ' ', ' ', ' ', ' ', ' ', ' ', ' ', ' '};
  
  String[] fontList;
  
  PVector pos;
  
  TwoHourString(String[] fList) {
    fontList = fList;
    angle = random(TAU);
    pos = new PVector(random(FRAME_WIDTH), random(FRAME_HEIGHT));
  }
  
  
  public void display() {
    fill(random(255), random(255), random(255));
    translate(pos.x, pos.y);
    rotate(angle);
    String theString = new String(typedLetters);
    PFont currentFont = createFont(fontList[floor(random(fontList.length))], 1 + random(24));
    textFont(currentFont);
    text(theString, 0, 0);
    rotate(-angle);
    translate(-pos.x, -pos.y);
  }
  
  public void addCharacter(char c, int number) {
    typedLetters[number] = c;
  }
}
  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "TwoHoursForTwoHours" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
